Two Sum (LeetCode #1) | 3 Solutions with animations | Study Algorithms

แชร์
ฝัง
  • เผยแพร่เมื่อ 15 ธ.ค. 2024

ความคิดเห็น • 104

  • @nikoo28
    @nikoo28  3 ปีที่แล้ว +52

    At 12:58, I am supposed to add "8" to the hash table and not "11".
    Sorry for the error.

    • @atharvalaad8926
      @atharvalaad8926 4 หลายเดือนก่อน

      😅😅😅😅😅😅😅 15:52 😅😅😊😅😅😅 15:52 15:52 15:52 15:52 15:52 😅 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 😅 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 15:52 😅 15:52 15:52 15:52 15:52 15:52 15:52 15:52

  • @halimaomar9820
    @halimaomar9820 2 ปีที่แล้ว +49

    This is absolutely the best explanation on TH-cam. Everyone else goes straight to coding and doesn't break down the logic beforehand.

    • @nikoo28
      @nikoo28  2 ปีที่แล้ว +3

      Happy that I could help :)

  • @AKASH-fe6vy
    @AKASH-fe6vy 2 หลายเดือนก่อน +1

    So nice of you to put this in a simple yet insightful manner, thanks a lot.

  • @billyfigueroa1617
    @billyfigueroa1617 9 หลายเดือนก่อน +4

    Excellent content. This is the second video I watch which allows one to be able to devise a nicer solution simply by sorting the array. The hash map solution is genius and is not complicated
    I will now, always look at a problem and find out how I can solve it by first thinking "Would sorting this array help to simplify the solution"

    • @nikoo28
      @nikoo28  9 หลายเดือนก่อน +1

      Awesome, thank you!

    • @billyfigueroa1617
      @billyfigueroa1617 9 หลายเดือนก่อน

      @@nikoo28 you are welcomed

  • @bobbysokhi7296
    @bobbysokhi7296 4 หลายเดือนก่อน +2

    Underrated channel.

  • @Spear_of_Boudicca
    @Spear_of_Boudicca 2 หลายเดือนก่อน +1

    Good video, very similar to my university lectures.
    I think the reason a lot of people fail to learn some things on their own is that they just see code and want to understand it magically, you need to get the logic behind stuff.

  • @Rockstar-16
    @Rockstar-16 2 ปีที่แล้ว +3

    Sir😄, I have no words, I have never seen anyone explain this nicley, thank you so much❤

    • @nikoo28
      @nikoo28  2 ปีที่แล้ว

      Thank you so much for your kind words.

  • @wenkaiyang1487
    @wenkaiyang1487 ปีที่แล้ว +3

    thank you soooo much! I checked out so many videos about this question. finally your video helped me out! firmly subscribed to your channel

  • @aman_rockstar31
    @aman_rockstar31 4 หลายเดือนก่อน

    you r really an excellent teacher one thing i want to tell ur explanation is better that striver thanks for providing such videos

  • @jst8922
    @jst8922 11 หลายเดือนก่อน

    06:03 - Method 1: Using Sorting
    This is basically sliding window solution, when you have two pointers , left and right and you move them correspondingly.

  • @yowanehakuuu
    @yowanehakuuu ปีที่แล้ว

    I watched two other videos before coming here , to be honest you are the best one . I only understand from you because other people talk too long without explaining they talk about the problem not the solution. You even taught me the math side of this . Thank you , I subscribed. I will watch the rest of the solutions

    • @nikoo28
      @nikoo28  ปีที่แล้ว +1

      I prefer to focus on the problem. Language is a tool anyway, and they will keep changing and evolving. Thanks for the sub!!

  • @harihardhik3293
    @harihardhik3293 ปีที่แล้ว +1

    Such a great way of explaining this problem. You have redefined teaching sir!!! Amazing Work!!!!

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      Thanks a ton

  • @ayushtalks2.0
    @ayushtalks2.0 2 ปีที่แล้ว +8

    One of the best way of teaching . Sir Keep posting more videos of dsa. 👍👍

    • @nikoo28
      @nikoo28  2 ปีที่แล้ว +2

      Thank you so much for your support :)

  • @mister_hanss
    @mister_hanss ปีที่แล้ว +3

    Love the way you teach, TYSM☺

  • @joshuajacobs6855
    @joshuajacobs6855 ปีที่แล้ว

    Only just got into coding a few days ago coming from a teacher background. Great explanations!

  • @Karan-ow4wl
    @Karan-ow4wl 2 หลายเดือนก่อน

    Best Video Explanation so far !!!

  • @brahmithegod9558
    @brahmithegod9558 2 ปีที่แล้ว +1

    I was searching for the solution but do not found dryryn but u did it thank bro ❤️

  • @elizabeth00653
    @elizabeth00653 6 หลายเดือนก่อน

    Thank you for taking the time to create this video and make a clear explanation

  • @shacks-b3b
    @shacks-b3b 10 หลายเดือนก่อน

    Please keep uploading DSA/leetcode videos, they all are really helpful, thanks!

    • @nikoo28
      @nikoo28  10 หลายเดือนก่อน

      More to come!

  • @pooja3711
    @pooja3711 11 หลายเดือนก่อน

    you are the best.I really appreciate your hard work and step-by-step approach to how to overcome with a solution. Hats off

    • @nikoo28
      @nikoo28  11 หลายเดือนก่อน +1

      thanks for the appreciation and motivation :)

  • @sarthakgadge5223
    @sarthakgadge5223 5 หลายเดือนก่อน

    Thanks a lot, I was able to understand this problem thanks to your efforts.

  • @KaisarAnvar
    @KaisarAnvar ปีที่แล้ว +3

    You're by far the most detailed explainer I've seen. I've seen a few, but you're really amazing. Having a coding interview soon.

    • @nikoo28
      @nikoo28  ปีที่แล้ว +1

      All the very best for your upcoming interviews :)

  • @girdharipatel2
    @girdharipatel2 ปีที่แล้ว

    your explanation is for more better than other youtuber

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      Glad you feel that way :D

  • @RajKumar-li8dc
    @RajKumar-li8dc ปีที่แล้ว +1

    Best way to teach sir plz discuss more question and make a proper playlist ❤❤❤

    • @nikoo28
      @nikoo28  ปีที่แล้ว +1

      Check out my playlists in the channel :)

  • @japaneseger
    @japaneseger 2 ปีที่แล้ว

    You explained it very well, best video out there regarding this solution!!"!!!!

  • @1tav0
    @1tav0 2 ปีที่แล้ว +1

    Thank you for the video it really helped me!

  • @kishanbhadoriya8701
    @kishanbhadoriya8701 11 หลายเดือนก่อน

    Thank you very much, finally understood

  • @malkitsaggu
    @malkitsaggu 4 หลายเดือนก่อน

    Best explanation 👌

  • @dineshpatil6698
    @dineshpatil6698 2 ปีที่แล้ว

    such clear explantion , subscribed

  • @TV-wk7oo
    @TV-wk7oo ปีที่แล้ว

    Thank you, you are the best! Visualizing the code helped me a lot

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      You're welcome!

  • @pulastyadas3351
    @pulastyadas3351 2 ปีที่แล้ว

    awesome explanation..keep teaching us

  • @bivinnandhu781
    @bivinnandhu781 ปีที่แล้ว

    Thank you bro you do grate things
    your explanation is very simple and easy to understand
    Iam so happy to see this video

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      so happy to read this

  • @coldcases_2
    @coldcases_2 2 หลายเดือนก่อน +2

    sir @nikoo28 ,there is a mistake in two pointer approch i think where if => num1 and num2 are the same (e.g., nums = [3,3], target = 6), so code will return the same index for both numbers, especially if there are duplicates in the original array. for ex nums =
    [3,3]
    target =
    6
    Output
    [1,1]
    Expected
    [0,1] which is wrong so should we apply something else here?

    • @matthewzarate8851
      @matthewzarate8851 2 หลายเดือนก่อน

      I had a similar issue with this test case as well.
      The way I fixed it is I made sure I was only inserting a {key:value} pair into my hashMap (example: target - nums[index]) at the end of the for-loop. I evaluate if condition ( map.containsKey(target - nums[index]) ) first, if not satisfied then I insert this new {key:value} pair into my hashMap and continue on with the next iteration of the for-loop. This generalizes the solution to fix the [3,3] target = 6 case.
      Also I haven't tested Nikhil's solution but it looks correct to me.

    • @coldcases_2
      @coldcases_2 2 หลายเดือนก่อน

      @@matthewzarate8851 i was talking about two pointer approch there is mistake in two pointer approch i already give example in my comment

    • @matthewzarate8851
      @matthewzarate8851 2 หลายเดือนก่อน

      @@coldcases_2 There isn't a mistake in the two pointer approach. You need to add complexity for the case when i = j, that takes care of this special case.

    • @matthewzarate8851
      @matthewzarate8851 2 หลายเดือนก่อน

      @@coldcases_2 when doing the brute force method you can fix this condition by
      for () {
      for() {
      if (target == nums[I] + nums[J]) && I != J then return (I,J);
      }
      }
      This takes care of all test cases. We added some complexity in the if condition.

  • @AbhishekRamola-u7y
    @AbhishekRamola-u7y 5 หลายเดือนก่อน

    Kudos! Great explanation brother.P.s: Bro, you sound exactly like Pennywise from It.

  • @206_dindayalpatra3
    @206_dindayalpatra3 8 หลายเดือนก่อน +1

    Thank you ❤

  • @manjunathakaliwalLife_Atlanta
    @manjunathakaliwalLife_Atlanta 10 หลายเดือนก่อน +1

    Good one

  • @prakharpathak5899
    @prakharpathak5899 ปีที่แล้ว

    Very smooth sir

  • @sanjeewagunarathna1990
    @sanjeewagunarathna1990 2 ปีที่แล้ว

    Great video best explanation

  • @anchalsoni8614
    @anchalsoni8614 3 ปีที่แล้ว

    awesome video... keep making them

  • @AkaNuclear
    @AkaNuclear 7 หลายเดือนก่อน

    For the second solution where we are using hashmap, the time complexity of finding an element is also O(n) in case of hash collisions

    • @nikoo28
      @nikoo28  7 หลายเดือนก่อน

      For a very big input size, yes there will be collisions…but for the domain of this problem you should be just fine.
      Good to discuss this with your interviewer though 😄

  • @04.nehalsingh12
    @04.nehalsingh12 2 ปีที่แล้ว

    awesome tutorial sir

  • @aniketpurohit7601
    @aniketpurohit7601 11 หลายเดือนก่อน +1

    Amazing

  • @Programming-for-all-u2l
    @Programming-for-all-u2l 10 หลายเดือนก่อน +1

    I do not know why he gets very few likes and he is the best teacher for explaining the leetcode problems

    • @nikoo28
      @nikoo28  10 หลายเดือนก่อน +1

      so happy you believe in me. Please share the videos if possible. Trying my best with SEO to get ranked up in search results.

    • @ashishsonii
      @ashishsonii 3 หลายเดือนก่อน

      Brother don't stop making leetcode questions​@@nikoo28

  • @prachithakur7061
    @prachithakur7061 2 วันที่ผ่านมา

    we can do this question using two pointer???

  • @lipovgaming7245
    @lipovgaming7245 3 หลายเดือนก่อน

    but how do you return 2 elements.

  • @dipanwitasahoo6643
    @dipanwitasahoo6643 8 หลายเดือนก่อน

    Is this possible using binary search?

  • @im_andre6dev56
    @im_andre6dev56 ปีที่แล้ว

    Hi Nikhil, what program do you use to draw the solution?

    • @nikoo28
      @nikoo28  11 หลายเดือนก่อน

      GoodNotes 6

  • @kunalkheeva
    @kunalkheeva 2 ปีที่แล้ว

    thank you for a great explanation, what would be its space complexity?

    • @nikoo28
      @nikoo28  2 ปีที่แล้ว

      Which solution do you want the space complexity for? :)

  • @juledoc_07
    @juledoc_07 ปีที่แล้ว

    I had a question about the tastable, 19-4 is 15, but it is on the table so why don't we stop there? Thank you

  • @TanviTiwari-lu6sf
    @TanviTiwari-lu6sf หลายเดือนก่อน

    I caan easily understand this code

  • @Samtoosoon
    @Samtoosoon 6 หลายเดือนก่อน +1

    Best

  • @sunnyrajesh
    @sunnyrajesh 7 หลายเดือนก่อน

    Hello I have a small doubt ? How we return two index values here map.get(complement),i);
    Can any one explain 🤔 does it return complement index and current I value ?

  • @karthik-varma-1579
    @karthik-varma-1579 8 หลายเดือนก่อน

    AT 10:31 the method is not working for negative numbers in the array;

    • @nikoo28
      @nikoo28  8 หลายเดือนก่อน +1

      the optimized method takes care of all different test cases

    • @karthik-varma-1579
      @karthik-varma-1579 8 หลายเดือนก่อน

      @@nikoo28 Ohk Thanks Sir

  • @shubhi1396
    @shubhi1396 2 หลายเดือนก่อน

    Why new is written in return

  • @ymhuang651
    @ymhuang651 2 ปีที่แล้ว

    Awesome channel! Why I Find it so late?

    • @nikoo28
      @nikoo28  2 ปีที่แล้ว

      Glad I could help you 😄

  • @ME022GopinathanAsokan
    @ME022GopinathanAsokan ปีที่แล้ว

    sir
    what language you are used here

    • @nikoo28
      @nikoo28  11 หลายเดือนก่อน

      Java

  • @kashmirviews4332
    @kashmirviews4332 7 หลายเดือนก่อน

    Can anybody tell how to write the main function code for the same function.

    • @nikoo28
      @nikoo28  7 หลายเดือนก่อน +1

      Just create an object of the class and call it in the main method

    • @kashmirviews4332
      @kashmirviews4332 7 หลายเดือนก่อน

      @@nikoo28 thanks.

  • @shwetamandal6616
    @shwetamandal6616 ปีที่แล้ว

    what is this """'' return new int[]{map.get(complement),i}; """" ? as it throws error and i am getting you've used curly brackets with new int[]...................please reply..........................

    • @nikoo28
      @nikoo28  ปีที่แล้ว

      It gets the complement pair and then returns it as an array.

  • @sushant3530
    @sushant3530 2 ปีที่แล้ว

    Sir will 3rd Method will work if array has Duplicate elements . Becoz in HashMap , the key cannot be duplicate. And if array elements repeats , they duplicate key is found. PLZZZZ PLZZ EXPLIAN THIS SIR

    • @nikoo28
      @nikoo28  2 ปีที่แล้ว

      since the problem says you will have EXACTLY ONE SOLUTION, you do not need to worry about duplicate number. Because if a duplicate number exists, then you will have 2 possible solutions...and hence that is not a valid scenario.

    • @ashishkumaryadav7701
      @ashishkumaryadav7701 ปีที่แล้ว

      @@nikoo28 but in the example there is repetitive element

    • @RapJunkie
      @RapJunkie 5 หลายเดือนก่อน

      @@nikoo28 we have a valid scenario [3,3], and this method won't work :(

  • @IorgaArtStudio
    @IorgaArtStudio 3 ปีที่แล้ว

    subbed!

  • @ganesang7217
    @ganesang7217 ปีที่แล้ว

    its cool

  • @ashishsonii
    @ashishsonii 3 หลายเดือนก่อน

    Dont stop DSA questions

  • @powerball200
    @powerball200 ปีที่แล้ว +1

    bro plz do in python

  • @ssss22144
    @ssss22144 หลายเดือนก่อน

    🎉

  • @YNKeerthi-ry6jx
    @YNKeerthi-ry6jx 8 หลายเดือนก่อน +1

    koko eating banana 875 leetcode question

    • @nikoo28
      @nikoo28  7 หลายเดือนก่อน +1

      It is available now: th-cam.com/video/JGYXNpZaW2U/w-d-xo.htmlsi=2ftslOTD1LCE8-r2

  • @abhinavd2
    @abhinavd2 2 ปีที่แล้ว

    100

  • @ssss22144
    @ssss22144 หลายเดือนก่อน

    😢

  • @RajuBandaru-x1d
    @RajuBandaru-x1d 15 วันที่ผ่านมา

    Problem 1:
    Description:
    Given a number
    𝑛
    n, write a function to find the largest number that has the same set of digits as
    𝑛
    n but is smaller than
    𝑛
    n. If no such number exists, return an appropriate message.
    Example:
    Input:
    𝑛
    =
    531476
    n=531476
    Output:
    531467
    531467